
unit uPass;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm4 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Edit1: TEdit;
    Timer1: TTimer;
    Label2: TLabel;
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
    fPass: string;
    fTime: Integer;
  public
    { Public declarations }
    fPassOK: Boolean;
  end;

var
  Form4: TForm4;

function AskPass(var aPass: string): Boolean;

implementation

{$R *.DFM}

uses
  HomeTool, uSet;

function AskPass(var aPass: string): Boolean;
begin
  Result := True;
  with Form4 do
    if not fPassOK then begin
      fTime := 0;
      Timer1.Enabled := True;
      Label2.Caption := '';
      if (ShowModal = mrOK) then begin
	aPass := Edit1.Text;
	fPass := aPass;
      end
      else Result := False;
      Timer1.Enabled := False;
    end
    else
      aPass := fPass;
end;

procedure TForm4.Timer1Timer(Sender: TObject);
var
  lZ: Integer;
begin
  lZ := Str2Int(Form2.Edit6.Text, 20);
  Label2.Caption := 'You have ' + IntToStr(lZ - fTime) + ' sec. left';
  Inc(fTime);
  if (fTime > lZ) then begin
    Timer1.Enabled := False;
    ModalResult := mrCancel;
  end;
end;

end.
