
unit uSet;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TForm2 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    CB1: TCheckBox;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    CB2: TCheckBox;
    Memo1: TMemo;
    CB3: TCheckBox;
    CB4: TCheckBox;
    Label11: TLabel;
    Edit9: TEdit;
    procedure BSaveClick(Sender: TObject);
    procedure BRestoreClick(Sender: TObject);
    procedure BOKClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    procedure DoSave;
    procedure FillEmailer;
  public
    { Public declarations }
    function DoRestore: Boolean;
  end;

const
  regAppName	= 'EMAILCHECKER';
  regSettings	= 'Settings';

var
  Form2: TForm2;

implementation

{$R *.DFM}

uses
  HomeTool, uMain2;

function Bool2Str(aValue: Boolean): Char;
begin
  if aValue then Result := '1'
	    else Result := '0';
end;

function Str2Bool(const aValue: string): Boolean;
begin
  Result := (aValue <> '') and (aValue[1] = '1');
end;

function tForm2.DoRestore: Boolean;
var
  lS: tStrings;
//  lR: Integer;
//  lZ: string;
//  lT: string;
//   i: Integer;
//  lB: Byte;
//  lP: Integer;
begin
  //Timer1.Enabled  := False;
  lS := tStringList.Create;
  try
    Edit1.Text := '192.168.1.1';
    Edit4.Text := 'pop3';
    Edit7.Text := '192.168.1.1';
    Edit8.Text := 'smtp';
    Edit2.Text := 'User';
    //Edit3.Text := '';
    Edit5.Text := '120';
    Edit6.Text := '20';
    Edit9.Text := 'Transformers <trans@formers.ru.lez>';
    CB1.Checked := True;
    lS.Text := GetRegStr(regAppName, regSettings, '');
    Result := (lS.Text <> '');
    if (lS.Count > 0) then Edit1.Text := lS[0];
    if (lS.Count > 1) then Edit4.Text := lS[1];
    if (lS.Count > 2) then Edit2.Text := lS[2];
    {if (lS.Count > 3) then begin
      lZ := lS[3];
      lP := Pos('-', lZ);
      if (lP > 1) then begin
	lR := Str2Int(Copy(lZ, 1, lP - 1), -1);
	if (lR >= 0) then begin
	  i := lP + 1;
	  lT := '';
	  while (i <= Length(lZ) - 1) do begin
	    lB := ((Byte(lZ[i]) - Byte('A')) and $0F) + ((Byte(lZ[i + 1]) - Byte('A') and $0F) shl 4);
	    lT := Chr(lB xor lR) + lT;
	    Inc(i, 2);
	  end;
	  lS[3] := lT;
	end;
      end;
      Edit3.Text := lS[3];
    end;}
    if (lS.Count > 4)  then Edit5.Text  := lS[4];	// this will change interval
    if (lS.Count > 5)  then Edit6.Text  := lS[5];
    if (lS.Count > 6)  then CB1.Checked := Str2Bool(lS[6]);
    if (lS.Count > 7)  then Edit7.Text  := lS[7];
    if (lS.Count > 8)  then Edit8.Text  := lS[8];
    if (lS.Count > 9)  then CB2.Checked := Str2Bool(lS[9]);
    if (lS.Count > 10) then CB3.Checked := Str2Bool(lS[10]);
    if (lS.Count > 11) then CB4.Checked := Str2Bool(lS[11]);
    if (lS.Count > 12) then Edit9.Text  := lS[12];
    //if (lS.Count > 13) then CB5.Checked := Str2Bool(lS[13]);
  finally
    lS.Free;
    FillEmailer;
  end;
end;

procedure tForm2.FillEmailer;
begin
  with Form1.Emailer1 do begin
    UserName   := Edit2.Text;
    //UserPass   := Edit3.Text;
    InServer   := Edit1.Text;
    InPort     := Edit4.Text;
    OutServer  := Edit7.Text;
    OutPort    := Edit8.Text;
    CheckEvery := Str2Int(Edit5.Text, 240);
    Edit5.Text := IntToStr(CheckEvery);
    TimeOut    := Str2Int(Edit6.Text, 20);
    Edit6.Text := IntToStr(TimeOut)
  end;
end;

procedure tForm2.DoSave;
//var
//  lS: string;
//  lZ: string;
//  lL: Integer;
//  lR: Integer;
//  lB: Byte;
//   i: Integer;
begin
  {lR := Random($100-$10) + $0F;
  lS := Edit3.Text;
  lL := Length(lS);
  lZ := '';
  for i := 1 to lL do begin
    lB := Byte(lS[lL - i + 1]) xor lR;
    lZ := lZ + Chr(lB and $0F + Byte('A')) + Chr((lB and $F0) shr 4 + Byte('A'));
  end;
  lZ := IntToStr(lR) + '-' + lZ;}
  SetRegStr(regAppName, regSettings,
    Edit1.Text + #13#10 +
    Edit4.Text + #13#10 +
    Edit2.Text + #13#10 +
    'NoMorePass'#13#10 +
    Edit5.Text + #13#10 +
    Edit6.Text + #13#10 +
    Bool2Str(CB1.Checked) + #13#10 +
    Edit7.Text + #13#10 +
    Edit8.Text + #13#10 +
    Bool2Str(CB2.Checked) + #13#10 +
    Bool2Str(CB3.Checked) + #13#10 +
    Bool2Str(CB4.Checked) + #13#10 +
    Edit9.Text 
    //Bool2Str(CB5.Checked)
    );
  FillEmailer;
end;

procedure TForm2.BSaveClick(Sender: TObject);
begin
  DoSave;
end;

procedure TForm2.BRestoreClick(Sender: TObject);
begin
  DoRestore;
end;

procedure TForm2.BOKClick(Sender: TObject);
begin
  FillEmailer;
  ModalResult := mrOK;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  if DoRestore then begin
    Form1.Emailer1.CheckActive := True;
    Form1.DoCheck;
  end
  else
    if (ShowModal = mrOK) then Form1.Emailer1.CheckActive := True;
end;

procedure TForm2.FormShow(Sender: TObject);
begin
  Memo1.Text := Form1.fLog.Text;
end;

end.

